// Loesung zur Aufgabe Pendel
//*****************************
// 
// von: Manfred Pester
// vom: 16.02.2017 
// letzte Aenderung: 2013_01_22 Stromsparfunktionalitaet
// Es koennte alles abgeschaltet werden, was nicht benoetigt wird

#include "../h/pio.h"
#include "../h/tc.h"
#include "../h/pmc.h"
#include "../h/aic.h"
#include "../h/usart.h"


int Taste = 0;
char Zeichen = 0;

void putseriell(char *String);
void USART0On(void);
void USART0Off(void);
void KEY1IntOn(void);
void KEY2IntOn(void);
void KEY1IntOff(void);
void KEY2IntOff(void);
void ENDTXIntOn(void);
void ENDTXIntOff(void);
void TXEMPTYIntOn(void);
void TXEMPTYIntOff(void);
int Messung_Periodendauer(void);
int Messung_Kuckeldicke(void);
int Messung_Schwingung(void);


void taste_irq_handler (void) __attribute__ ((interrupt));
void usart0_irq_handler (void) __attribute__ ((interrupt));

// 
void taste_irq_handler (void)
{
	volatile unsigned int PIO_IRQ_Status;
  	
// ab hier entsprechend der Aufgabestellung ergänzen
//**************************************************
	PIO_IRQ_Status = PIOB_BASE->PIO_ISR;
 	
  if(PIO_IRQ_Status & KEY1)	
  {
//		 PIOB_BASE->PIO_CODR = LED1;	
		 Taste = 1;
  }
  if((PIO_IRQ_Status & KEY2) && (Taste == 1))	
  {
//		 PIOB_BASE->PIO_SODR = LED1;
		 Taste = 2;
  }

	AIC_BASE->AIC_EOICR =  PIOB_BASE->PIO_ISR;	//__
}



// 
void usart0_irq_handler (void)
{
	volatile unsigned int USART0_CSR_Status;
  	
// ab hier entsprechend der Aufgabenstellung ergaenzen
//****************************************************
	USART0_CSR_Status = USART0->US_CSR;
 
// pruefen ob ein Zeichen empfangen wurde und dann Zeichen zuweisen		
  if(USART0_CSR_Status & 0x1)	
  {
		 Zeichen = USART0->US_RHR;
  }
// pruefen ob String ausgegeben ist Interrupt ausschalten  
  if(USART0_CSR_Status & 0x200)
  {
	TXEMPTYIntOff();
  }

	AIC_BASE->AIC_EOICR =  USART0->US_CSR;	//__
}


// Initialisierung der PIO
// Nutzung der Tasten auf dem Board AT91EB63
void	USART0On (void)
{
	PMC_BASE->PMC_PCER	= 0x04;	// USART0 Clock einschalten
}

void	USART0Off (void)
{		

	PMC_BASE->PMC_PCDR	= 0x04;	// USART0 Clock ausschalten
}

void	KEYsOn (void)
{
	PMC_BASE->PMC_PCER	= 0x04000;	// Clock PIOB einschalten
}

void	KEYsOff (void)
{
	PMC_BASE->PMC_PCDR	= 0x04000;	// Clock PIOB ausschalten
}

void	KEY1IntOn (void)
{

	PIOB_BASE->PIO_IER = KEY1;	// Interrupt von KEY1 deaktivieren
}

void	KEY2IntOn (void)
{
	PIOB_BASE->PIO_IER = KEY2;	// Interrupt von KEY1 deaktivieren
}

void	KEY1IntOff (void)
{
	PIOB_BASE->PIO_IDR = KEY1;	// Interrupt von KEY1 deaktivieren
}

void	KEY2IntOff (void)
{
	PIOB_BASE->PIO_IDR = KEY2;	// Interrupt von KEY1 deaktivieren
}

void	RXRDYIntOn (void)
{
	USART0->US_IER = 0x1;	// Interrupt von TXRDY aktivieren
}
	
void	RXRDYIntOff (void)
{
	USART0->US_IDR = 0x1;	// Interrupt von TXRDY aktivieren
}

void	ENDTXIntOn (void)
{
	USART0->US_IER = 0x10;	// Interrupt von TXRDY aktivieren
}
	
void	ENDTXIntOff (void)
{
	USART0->US_IDR = 0x10;	// Interrupt von TXRDY aktivieren
}

void	TXEMPTYIntOn (void)
{
	USART0->US_IER = 0x200;	// Interrupt von TXRDY aktivieren
}
	
void	TXEMPTYIntOff (void)
{
	USART0->US_IDR = 0x200;	// Interrupt von TXRDY aktivieren
}
	

// fuer die Initialisierung des Zaehler TC2
// Messung der Kugeldicke
#define TC2_INIT_Kuckeldicke   TC_CLKS_MCK1024 | TC_LDBSTOP | TC_CAPT | TC_LDRA_RISING_EDGE  | TC_LDRB_FALLING_EDGE
// Messung der Schwingung links bzw. rechts
#define TC2_INIT_Schwingung    TC_CLKS_MCK1024 | TC_LDBSTOP | TC_CAPT | TC_LDRA_FALLING_EDGE | TC_LDRB_RISING_EDGE
// Messung 
#define TC2_INIT_1halbePeriode TC_CLKS_MCK1024 | TC_LDBSTOP | TC_CAPT | TC_LDRA_FALLING_EDGE | TC_LDRB_FALLING_EDGE
#define TC2_INIT_2halbePeriode TC_CLKS_MCK1024 | TC_LDBSTOP | TC_CAPT | TC_LDRA_RISING_EDGE  | TC_LDRB_RISING_EDGE

void Timer_Init(void)
{
	PMC_BASE->PMC_PCER	= 0x04100;	// Clock Timer2 und PIOA einschalten
	PIOB_BASE->PIO_PDR	= 0x04000000;	//1<<26;

	TCB2_BASE->TC_CCR	= TC_CLKDIS;
	TCB2_BASE->TC_CMR	= TC2_INIT_Kuckeldicke;
	TCB2_BASE->TC_CCR	= TC_CLKEN;
	TCB2_BASE->TC_CCR	= TC_SWTRG;

}

void Int2String(int Zahl)
{
	int i = 12;	// Stellen fuer 32bit Zahl mit Vorzeichen
	char Vorzeichen = ' ';
	unsigned char IntegerZahl[i];
	IntegerZahl[i] = 0;

	if ( Zahl == 0x80000000 )
	{
		putseriell("-2147483678");	
	}
	else
	{	
		if ( Zahl < 0 )
		{
			Zahl = Zahl * -1;
			Vorzeichen = '-';
		}	
		if ( Zahl== 0)
		{
			i -= 1;
			IntegerZahl[i] = '0';
		}
		else
		{	
			while( Zahl > 0 )
			{
				i -= 1;
				IntegerZahl[i] = (Zahl % 10) + '0';
				Zahl = Zahl / 10;			
			}
		}
		i -= 1;
		IntegerZahl[i] = Vorzeichen;

		putseriell(&IntegerZahl[i]);
	}	
}	

void KEY_Interupt(void)
// Interrupt fuer PIOB initialisieren
{
	KEYsOn();
	AIC_BASE->AIC_IDCR = 0x4000;	// Interrupt disablen
	AIC_BASE->AIC_ICCR = 0x4000;	// Interrupt loeschen
	AIC_BASE->AIC_SMR[14] = 0x02;	// High-Level Sensitive, Prioritaet 
	AIC_BASE->AIC_SVR[14] = (unsigned int)  taste_irq_handler;	// IRQ-Vector
	PIOB_BASE->PIO_IDR = 0xffffffff;	// SW1 und SW2 Interrupt erlauben
	PIOB_BASE->PIO_IER = 0x18;	// SW1 und SW2 Interrupt erlauben
	PIOB_BASE->PIO_ISR;		// Interrups loeschen
	AIC_BASE->AIC_IECR = 0x4000;	// Interrrupt Enable
	KEYsOff();

}	
	 
void USART_Interupt(void)
// Interrupt fuer PIOB initialisieren
{
	AIC_BASE->AIC_IDCR = 0x4;	// Interrupt disablen
	AIC_BASE->AIC_ICCR = 0x4;	// Interrupt loeschen
	AIC_BASE->AIC_SMR[2] = 0x03;	// High-Level Sensitive, Prioritaet 
	AIC_BASE->AIC_SVR[2] = (unsigned int)  usart0_irq_handler;	// IRQ-Vector
	USART0->US_RHR;
	USART0->US_THR;
	USART0->US_IDR = 0xffffffff;	// Alle Interrupt der USART0 verbieten
	USART0->US_IER = 0x1;		// RXRDY Interrupt erlauben
	USART0->US_CSR;			// Interrups loeschen
	AIC_BASE->AIC_IECR = 0x4;	// Interrrupt Enable
}	

// putseriell gibt einen String aus und haelt solange die CPU an
void putseriell(char *String)
{
// ermitteln der Stringlaenge Anzahl
	int Anzahl = 0;
	for (Anzahl = 0; String[Anzahl]!=0; Anzahl++);
	
	USART0->US_TPR = (unsigned int) &String[0];
	USART0->US_TCR = Anzahl;
	TXEMPTYIntOn();

// CPU anhalten und Pruefen ob serielle frei fuer naechsten String
	PMC_BASE->PMC_SCDR	= 0x1;		//CPU anhalten Clock abschalten
}

// Messung_Periodendauer
// 
int Messung_Periodendauer(void)
{
			
	volatile T = 0;
	
	TCB2_BASE->TC_CCR	=	TC_CLKDIS;
	TCB2_BASE->TC_CMR	=	TC2_INIT_Kuckeldicke;
	TCB2_BASE->TC_CCR	=	TC_CLKEN;
	TCB2_BASE->TC_SR;	// Statusregister lesen um es zu loeschen
	TCB2_BASE->TC_CCR	=	TC_SWTRG;
	while (!( TCB2_BASE->TC_SR & 0x40));		// Capture Register B wurde geladen Messung abgeschlossen
	T = TCB2_BASE->TC_RB - TCB2_BASE->TC_RA ;	// 

	TCB2_BASE->TC_CCR	=	TC_CLKDIS;
	TCB2_BASE->TC_CMR	=	TC2_INIT_Kuckeldicke;
	TCB2_BASE->TC_CCR	=	TC_CLKEN;
	TCB2_BASE->TC_SR;	// Statusregister lesen um es zu loeschen
	TCB2_BASE->TC_CCR	=	TC_SWTRG;
	while (!( TCB2_BASE->TC_SR & 0x40));		// Capture Register B wurde geladen Messung abgeschlossen
	T = T + TCB2_BASE->TC_RB - TCB2_BASE->TC_RA ;	// 

	TCB2_BASE->TC_CCR	=	TC_CLKDIS;
	TCB2_BASE->TC_CMR	=	TC2_INIT_Schwingung;
	TCB2_BASE->TC_CCR	=	TC_CLKEN;
	TCB2_BASE->TC_SR;	// Statusregister lesen um es zu loeschen
	TCB2_BASE->TC_CCR	=	TC_SWTRG;
	while (!( TCB2_BASE->TC_SR & 0x40));		// Capture Register B wurde geladen Messung abgeschlossen
	T = T + TCB2_BASE->TC_RB - TCB2_BASE->TC_RA ;	// 
	
	TCB2_BASE->TC_CCR	=	TC_CLKDIS;
	TCB2_BASE->TC_CMR	=	TC2_INIT_Schwingung;
	TCB2_BASE->TC_CCR	=	TC_CLKEN;
	TCB2_BASE->TC_SR;	// Statusregister lesen um es zu loeschen
	TCB2_BASE->TC_CCR	=	TC_SWTRG;
	while (!( TCB2_BASE->TC_SR & 0x40));		// Capture Register B wurde geladen Messung abgeschlossen
	T = T + TCB2_BASE->TC_RB - TCB2_BASE->TC_RA ;	// 

        T = (T * 1024 / 25);	// ergibt T in us
 	return T;
}	


int Messung_Kuckeldicke(void)
{
			
	volatile T = 0;
	
	TCB2_BASE->TC_CCR	=	TC_CLKDIS;
	TCB2_BASE->TC_CMR	=	TC2_INIT_Kuckeldicke;
	TCB2_BASE->TC_CCR	=	TC_CLKEN;
	TCB2_BASE->TC_SR;	// Statusregister lesen um es zu loeschen
	TCB2_BASE->TC_CCR	=	TC_SWTRG;
	while (!( TCB2_BASE->TC_SR & 0x40));		// Capture Register B wurde geladen Messung abgeschlossen
	T = TCB2_BASE->TC_RB - TCB2_BASE->TC_RA ;	// 
        T = (T * 1024 / 25);	// ergibt T in us
 	return T;
}	


int Messung_Schwingung(void)
{
			
	volatile T = 0;
	
	TCB2_BASE->TC_CCR	=	TC_CLKDIS;
	TCB2_BASE->TC_CMR	=	TC2_INIT_Schwingung;
	TCB2_BASE->TC_CCR	=	TC_CLKEN;
	TCB2_BASE->TC_SR;	// Statusregister lesen um es zu loeschen
	TCB2_BASE->TC_CCR	=	TC_SWTRG;
	while (!( TCB2_BASE->TC_SR & 0x40));		// Capture Register B wurde geladen Messung abgeschlossen
	T = T + TCB2_BASE->TC_RB - TCB2_BASE->TC_RA ;	// 

        T = (T * 1024 / 25);	// ergibt T in us
 	return T;
}	

	 
int main(void)
{

	int T = 0;
	int Kuckeldicke1;
	int Kuckeldicke2;
	int Schwingung1;
	int Schwingung2;
	int T_Liste[19];
	int i=0;
	
		
// USART0 Clock an
	PMC_BASE->PMC_PCER	= 0x2104;	// USART0 Clock an
		
	init_ser();
	Timer_Init();
	KEY_Interupt();
	USART_Interupt();
	
	while(1)
	{
		putseriell("\n Hallo setzen Sie das Pendel in Bewegung\n und druecken Sie die Taste1!\n");
		
		Taste = 0;
		Zeichen = 0;

		while( Zeichen != '1');			// Taste 1 gedrueckt?
			
		putseriell("\nSie haben die Taste 1 gedrueckt die Messung laeuft.\nPeriodendauer T = ");
		T = Messung_Periodendauer();
		Int2String(T);
		putseriell(" mikrosekunden\n");

		putseriell("\nSie haben die Taste 1 gedrueckt die Messung laeuft.\nKuckeldicke1 = ");
		Kuckeldicke1 = Messung_Kuckeldicke();
		Int2String(Kuckeldicke1);
		putseriell(" mikrosekunden\n");

		putseriell("\nSie haben die Taste 1 gedrueckt die Messung laeuft.\nKuckeldicke2 = ");
		Kuckeldicke2 = Messung_Kuckeldicke();
		Int2String(Kuckeldicke2);
		putseriell(" mikrosekunden\n");

		putseriell("\nSie haben die Taste 1 gedrueckt die Messung laeuft.\nSchwingung1 = ");
		Schwingung1 = Messung_Schwingung();
		Int2String(Schwingung1);
		putseriell(" mikrosekunden\n");

		putseriell("\nSie haben die Taste 1 gedrueckt die Messung laeuft.\nSchwingung2 = ");
		Schwingung2 = Messung_Schwingung();
		Int2String(Schwingung2);
		putseriell(" mikrosekunden\n");
		
		T=Kuckeldicke1+Kuckeldicke2+Schwingung1+Schwingung2;
		putseriell("\nPeriodendauer = ");
		Int2String(T);
		putseriell(" mikrosekunden\n");
		
		for (i=0; i<=20; i++)
		{
			putseriell("\n T_Liste[");
			Int2String(i);
			putseriell("] = ");
			T = Messung_Periodendauer();
			Int2String(T);
			T_Liste[i] = T;
		}
		for (i=0; i<=20; i++)
		{
			T_Liste[i] = T_Liste[i+1]-T_Liste[i];
		}


	}
	
	return 0;
}

